coreutils
[Top][All Lists]
Advanced

[Date Prev][Date Next][Thread Prev][Thread Next][Date Index][Thread Index]

[PATCH] tests: cp/sparse-perf: make more robust and add zfs comments


From: Pádraig Brady
Subject: [PATCH] tests: cp/sparse-perf: make more robust and add zfs comments
Date: Sat, 25 Sep 2021 14:38:33 +0100

* init.cfg (seek_data_capable_): Add a timeout to ensure failure for
slow lseek(...SEEK_DATA) calls (even if that syscall isn't interrupted).
* tests/cp/sparse-perf.sh: Run the SEEK_DATA check on the
1TiB empty file to exclude both FreeBSD 9.1 which takes 35s,
and ZFS which requires a delay of 3s between file creation
and use of SEEK_DATA to correctly determine it's empty (return ENXIO).
Also remove the stat size checks as they invalidate the test
due to cp never writing data due to it being always zeros,
and thus converted to holes in the output.
---
 init.cfg                |  9 ++++++++-
 tests/cp/sparse-perf.sh | 26 ++++++++++----------------
 2 files changed, 18 insertions(+), 17 deletions(-)

diff --git a/init.cfg b/init.cfg
index 714854648..b92f717f5 100644
--- a/init.cfg
+++ b/init.cfg
@@ -540,7 +540,14 @@ seek_data_capable_()
       warn_ 'seek_data_capable_: python missing: assuming not SEEK_DATA 
capable'
       return 1
   fi
-  $PYTHON_ "$abs_srcdir"/tests/seek-data-capable "$@"
+
+  # Use timeout if available to skip cases where SEEK_DATA takes a long time.
+  # We saw FreeBSD 9.1 take 35s to return from SEEK_DATA for a 1TiB empty file.
+  # Note lseek() is uninterruptible on FreeBSD 9.1, but it does eventually
+  # return, and the timeout will ensure a failure return from the process.
+  timeout --version >/dev/null && TIMEOUT_='timeout 10'
+
+  $TIMEOUT_ $PYTHON_ "$abs_srcdir"/tests/seek-data-capable "$@"
 }
 
 # Skip the current test if "." lacks d_type support.
diff --git a/tests/cp/sparse-perf.sh b/tests/cp/sparse-perf.sh
index fafbf2275..e5668eb1c 100755
--- a/tests/cp/sparse-perf.sh
+++ b/tests/cp/sparse-perf.sh
@@ -1,7 +1,7 @@
 #!/bin/sh
 # ensure that a sparse file is copied efficiently, by default
 
-# Copyright (C) 2011-2021 Free Software Foundation, Inc.
+# Copyright (C) 2021 Free Software Foundation, Inc.
 
 # This program is free software: you can redistribute it and/or modify
 # it under the terms of the GNU General Public License as published by
@@ -19,25 +19,19 @@
 . "${srcdir=.}/tests/init.sh"; path_prepend_ ./src
 print_ver_ cp
 
-touch sparse_chk
-seek_data_capable_ sparse_chk ||
-  skip_ "this file system lacks SEEK_DATA support"
-
 # Create a large-but-sparse file.
 timeout 10 truncate -s1T f ||
   skip_ "unable to create a 1 TiB sparse file"
 
-# Nothing can read (much less write) that many bytes in so little time.
-timeout 10 cp --reflink=never f f2
-ret=$?
-if test $ret -eq 124; then  # timeout
-  # Only fail if we allocated more data
-  # as we've seen SEEK_DATA taking 35s on some freebsd VMs
-  test $(stat -c%b f2) -gt $(stat -c%b f) && fail=1 ||
-    skip_ "SEEK_DATA timed out"
-elif test $ret -ne 0; then
-  fail=1
-fi
+# Note zfs (tested on ubuntu 21.04 and 21.10 at least)
+# will generally skip here, due to needing at least 3 seconds
+# between the creation of the file and the use of SEEK_DATA,
+# for it to determine it's an empty file (return ENXIO).
+seek_data_capable_ f ||
+  skip_ "this file system lacks appropriate SEEK_DATA support"
+
+# Nothing can read that many bytes in so little time.
+timeout 10 cp --reflink=never f f2 || fail=1
 
 # Ensure that the sparse file copied through SEEK_DATA has the same size
 # in bytes as the original.
-- 
2.26.2




reply via email to

[Prev in Thread] Current Thread [Next in Thread]